using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;

public class CubeMovement : MonoBehaviour {
	public bool  is_server = true;
	public float speed     = 250.0f;
	
	//This is the only way I know how to make a const array of const elements in C#
	static readonly ReadOnlyCollection<Vector3> OFFSETS = new List<Vector3>{
		Vector3.right,
		Vector3.up,
		Vector3.left,
		Vector3.down
	}.AsReadOnly();
	
	// Update is called once per frame
	void Update () {
		float delta_pos = Time.deltaTime * speed;
		
		if (is_server == Network.isServer) {
			bool[] key_press = {
				Input.GetKey(KeyCode.RightArrow),
				Input.GetKey(KeyCode.UpArrow),
				Input.GetKey(KeyCode.LeftArrow),
				Input.GetKey(KeyCode.DownArrow)
			};
			
			for (int i=0; i<key_press.Length; ++i) {
				if (key_press[i]) {
					transform.position += CubeMovement.OFFSETS[i] * delta_pos;
				}
			}
		}
	}
	
	//This is what you call to set the ownership of the cube
	public void setServerStatus (bool is_server) {
		//This RPC syncs the cube's server status on the other player's game
		//It, however, won't call RPCsetServerStatus() on this game
		this.networkView.RPC("RPCsetServerStatus", RPCMode.All, is_server);
		//Which is why we call it manually here
		this.RPCsetServerStatus(is_server);
	}
	
	[RPC]
	void RPCsetServerStatus (bool is_server) {
		this.is_server = is_server;
	}
}
